"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[35678],{803305:(e,n,i)=>{i.r(n),i.d(n,{assets:()=>a,contentTitle:()=>r,default:()=>h,frontMatter:()=>s,metadata:()=>c,toc:()=>l});var t=i(785893),o=i(511151);const s={title:"OAuth Source"},r=void 0,c={id:"sources/oauth/index",title:"OAuth Source",description:"This source allows users to enroll themselves with an external OAuth-based Identity Provider. The generic provider expects the endpoint to return OpenID-Connect compatible information. Vendor-specific implementations have their own OAuth Source.",source:"@site/docs/sources/oauth/index.md",sourceDirName:"sources/oauth",slug:"/sources/oauth/",permalink:"/docs/sources/oauth/",draft:!1,unlisted:!1,editUrl:"https://github.com/goauthentik/authentik/edit/main/website/docs/sources/oauth/index.md",tags:[],version:"current",frontMatter:{title:"OAuth Source"},sidebar:"docs",previous:{title:"LDAP Source",permalink:"/docs/sources/ldap/"},next:{title:"SAML Source",permalink:"/docs/sources/saml/"}},a={},l=[{value:"OpenID Connect",id:"openid-connect",level:3},{value:"Well-known",id:"well-known",level:4},{value:"JWKS",id:"jwks",level:4},{value:"OAuth source property mappings",id:"oauth-source-property-mappings",level:2},{value:"Expression data",id:"expression-data",level:3}];function d(e){const n={a:"a",admonition:"admonition",code:"code",h2:"h2",h3:"h3",h4:"h4",li:"li",p:"p",pre:"pre",ul:"ul",...(0,o.a)(),...e.components};return(0,t.jsxs)(t.Fragment,{children:[(0,t.jsx)(n.p,{children:"This source allows users to enroll themselves with an external OAuth-based Identity Provider. The generic provider expects the endpoint to return OpenID-Connect compatible information. Vendor-specific implementations have their own OAuth Source."}),"\n",(0,t.jsxs)(n.ul,{children:["\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsx)(n.p,{children:"Policies: Allow/Forbid users from linking their accounts with this provider."}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsx)(n.p,{children:"Request Token URL: This field is used for OAuth v1 implementations and will be provided by the provider."}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsx)(n.p,{children:"Authorization URL: This value will be provided by the provider."}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsx)(n.p,{children:"Access Token URL: This value will be provided by the provider."}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsx)(n.p,{children:"Profile URL: This URL is called by authentik to retrieve user information upon successful authentication."}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsx)(n.p,{children:"Consumer key/Consumer secret: These values will be provided by the provider."}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:["\n",(0,t.jsx)(n.p,{children:"Scopes: Configure additional scopes to send to the provider."}),"\n",(0,t.jsxs)(n.p,{children:["Starting with authentik 2022.10, the default scopes can be replaced by prefix the value for scopes with ",(0,t.jsx)(n.code,{children:"*"}),"."]}),"\n"]}),"\n"]}),"\n",(0,t.jsx)(n.h3,{id:"openid-connect",children:"OpenID Connect"}),"\n",(0,t.jsx)(n.admonition,{type:"info",children:(0,t.jsx)(n.p,{children:"Requires authentik 2022.6"})}),"\n",(0,t.jsx)(n.h4,{id:"well-known",children:"Well-known"}),"\n",(0,t.jsxs)(n.p,{children:["Instead of configuring the URLs for a source manually, and the application you're configuring implements the ",(0,t.jsx)(n.a,{href:"https://openid.net/specs/openid-connect-discovery-1_0.html",children:"OpenID Connect Discovery Spec"}),", you can configure the source with a single URL. The URL should always end with ",(0,t.jsx)(n.code,{children:".well-known/openid-configuration"}),". Many applications don't explicitly mention this URL, but for most of them it will be ",(0,t.jsx)(n.code,{children:"https://application.company/.well-known/openid-configuration"}),"."]}),"\n",(0,t.jsx)(n.p,{children:"This URL is fetched upon saving the source, and all the URLs will be replaced by the ones from the Discovery document. No automatic re-fetching is done."}),"\n",(0,t.jsx)(n.h4,{id:"jwks",children:"JWKS"}),"\n",(0,t.jsx)(n.p,{children:'To simplify Machine-to-machine authentication, you can create an OAuth Source as "trusted" source of JWTs. Create a source and configure either the Well-known URL or the OIDC JWKS URL, or you can manually enter the JWKS data if you so desire.'}),"\n",(0,t.jsxs)(n.p,{children:["Afterwards, this source can be selected in one or multiple OAuth2 providers, and any JWT issued by any of the configured sources' JWKS will be able to authenticate. To learn more about this, see ",(0,t.jsx)(n.a,{href:"/docs/providers/oauth2/client_credentials#jwt-authentication",children:"JWT-authentication"}),"."]}),"\n",(0,t.jsx)(n.h2,{id:"oauth-source-property-mappings",children:"OAuth source property mappings"}),"\n",(0,t.jsxs)(n.p,{children:["See the ",(0,t.jsx)(n.a,{href:"/docs/sources/property-mappings/",children:"overview"})," for information on how property mappings work."]}),"\n",(0,t.jsx)(n.h3,{id:"expression-data",children:"Expression data"}),"\n",(0,t.jsx)(n.p,{children:"The following variables are available to OAuth\xa0source property mappings:"}),"\n",(0,t.jsxs)(n.ul,{children:["\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"info"}),": A Python dictionary containing OAuth claims. For example (values might differ depending on the source):","\n",(0,t.jsx)(n.pre,{children:(0,t.jsx)(n.code,{className:"language-python",children:'{\n    "iss": "https://source.company",\n    "sub": "f153e7da687eec8c8789c72b6cc6bb5197df7b48b263b3151f36908e1bc10691",\n    "aud": "01e4DmQiG1d3kaewD3Mkz7E7kXknk9j43eZMkNaE",\n    "aud": "a7809c1b1c4aaa50adfb68660a6273dd9c8d15e4",\n    "email": "user@authentik.company",\n    "email_verified": True,\n    "name": "User",\n    "given_name": "User",\n    "preferred_username": "user",\n    "nickname": "user",\n}\n'})}),"\n"]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"client"}),": An OAuth client object to make requests to the Source with authentication built-in."]}),"\n",(0,t.jsxs)(n.li,{children:[(0,t.jsx)(n.code,{children:"token"}),": A Python dictionary containing OAuth tokens."]}),"\n"]})]})}function h(e={}){const{wrapper:n}={...(0,o.a)(),...e.components};return n?(0,t.jsx)(n,{...e,children:(0,t.jsx)(d,{...e})}):d(e)}}}]);