"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[34223],{938069:(e,t,n)=>{n.r(t),n.d(t,{assets:()=>d,contentTitle:()=>s,default:()=>h,frontMatter:()=>o,metadata:()=>l,toc:()=>c});var i=n(785893),a=n(511151);const o={title:"Stages"},s=void 0,l={id:"flow/stages/index",title:"Stages",description:"Stages are one of the fundamental building blocks in authentik, along with flows and policies.",source:"@site/docs/flow/stages/index.md",sourceDirName:"flow/stages",slug:"/flow/stages/",permalink:"/docs/flow/stages/",draft:!1,unlisted:!1,editUrl:"https://github.com/goauthentik/authentik/edit/main/website/docs/flow/stages/index.md",tags:[],version:"current",frontMatter:{title:"Stages"},sidebar:"docs",previous:{title:"Headless",permalink:"/docs/flow/executors/headless"},next:{title:"Duo authenticator setup stage",permalink:"/docs/flow/stages/authenticator_duo/"}},d={},c=[{value:"Create a Stage",id:"create-a-stage",level:2},{value:"Bind a stage to a flow",id:"bind-a-stage-to-a-flow",level:2}];function r(e){const t={a:"a",code:"code",em:"em",h2:"h2",li:"li",mermaid:"mermaid",ol:"ol",p:"p",strong:"strong",...(0,a.a)(),...e.components};return(0,i.jsxs)(i.Fragment,{children:[(0,i.jsxs)(t.p,{children:["Stages are one of the fundamental building blocks in authentik, along with ",(0,i.jsx)(t.a,{href:"/docs/flow/",children:"flows"})," and ",(0,i.jsx)(t.a,{href:"/docs/policies/",children:"policies"}),"."]}),"\n",(0,i.jsx)(t.p,{children:"A stage represents a single verification or logic step within a flow. You can bind one or more stages to a flow to create a customized, flexible login and authentication process."}),"\n",(0,i.jsxs)(t.p,{children:["In the following diagram of the ",(0,i.jsx)(t.code,{children:"default-authentication-flow"}),", you see multiple stages, or steps, in the authentication process for a user. Policies are bound to some stages; this provides for dynamic application of a specific stage ",(0,i.jsx)(t.em,{children:"if"})," the policy criteria is met."]}),"\n",(0,i.jsx)(t.mermaid,{value:'graph TD\nflow_pre[["Pre-flow policies"]]\nflow_pre --Binding 10--\x3e flow_policy_0{{"Policy (Event Matcher Policy)\ndefault-match-update"}}\nflow_policy_0 --Policy denied--\x3e done[["End of the flow"]]\nflow_policy_0 --\x3e flow_start[["Flow\nWelcome to authentik!"]]\nstage_0_policy_0 --Policy passed--\x3e stage_0(["Stage (Identification Stage)\ndefault-authentication-identification"])\nstage_1_policy_0 --Policy passed--\x3e stage_1(["Stage (Password Stage)\ndefault-authentication-password"])\n--\x3e stage_2(["Stage (Authenticator Validation Stage)\ndefault-authentication-mfa-validation"])\n--\x3e stage_3(["Stage (User Login Stage)\ndefault-authentication-login"])\nflow_start --\x3e stage_0_policy_0{{"Policy (Event Matcher Policy)\ndefault-match-configuration-error"}}\nstage_0 --\x3e stage_1_policy_0{{"Policy (Expression Policy)\ndefault-authentication-flow-password-stage"}}\nstage_0_policy_0 --Policy denied--\x3e stage_1(["Stage (Password Stage)\ndefault-authentication-password"])\nstage_1_policy_0 --Policy denied--\x3e stage_2(["Stage (Authenticator Validation Stage)\ndefault-authentication-mfa-validation"])\nstage_3 --\x3e done[["End of the flow"]]'}),"\n",(0,i.jsx)(t.h2,{id:"create-a-stage",children:"Create a Stage"}),"\n",(0,i.jsx)(t.p,{children:"To create a stage, follow these steps:"}),"\n",(0,i.jsxs)(t.ol,{children:["\n",(0,i.jsx)(t.li,{children:"Log in as an admin to authentik, and go to the Admin interface."}),"\n",(0,i.jsxs)(t.li,{children:["In the Admin interface, navigate to ",(0,i.jsx)(t.strong,{children:"Flows and Stages -> Stages"}),"."]}),"\n",(0,i.jsxs)(t.li,{children:["Click ",(0,i.jsx)(t.strong,{children:"Create"}),", define the flow using the configuration settings, and then click ",(0,i.jsx)(t.strong,{children:"Finish"}),"."]}),"\n"]}),"\n",(0,i.jsxs)(t.p,{children:["After creating the stage, you can then ",(0,i.jsx)(t.a,{href:"#bind-a-stage-to-a-flow",children:"bind the stage to a flow"})," or ",(0,i.jsx)(t.a,{href:"/docs/policies/working_with_policies/",children:"bind a policy to the stage"})," (the policy determines whether or not the stage will be implemented in the flow)."]}),"\n",(0,i.jsx)(t.h2,{id:"bind-a-stage-to-a-flow",children:"Bind a stage to a flow"}),"\n",(0,i.jsx)(t.p,{children:"To bind a stage to a flow, follow these steps:"}),"\n",(0,i.jsxs)(t.ol,{children:["\n",(0,i.jsx)(t.li,{children:"Log in as an admin to authentik, and go to the Admin interface."}),"\n",(0,i.jsxs)(t.li,{children:["In the Admin interface, navigate to ",(0,i.jsx)(t.strong,{children:"Flows and Stages -> Flows"}),"."]}),"\n",(0,i.jsx)(t.li,{children:"In the list of flows, click the name of the flow to which you want to bind one or more stages."}),"\n",(0,i.jsxs)(t.li,{children:["On the Flow page, click the ",(0,i.jsx)(t.strong,{children:"Stage Bindings"})," tab at the top."]}),"\n",(0,i.jsxs)(t.li,{children:["Here, you can decide if you want to create a new stage and bind it to the flow (",(0,i.jsx)(t.strong,{children:"Create and bind Stage"}),"), or if you want to select an existing stage and bind it to the flow (",(0,i.jsx)(t.strong,{children:"Bind existing stage"}),")."]}),"\n"]})]})}function h(e={}){const{wrapper:t}={...(0,a.a)(),...e.components};return t?(0,i.jsx)(t,{...e,children:(0,i.jsx)(r,{...e})}):r(e)}}}]);